.NOLIST
.INCLUDE "m8def.inc" ; ATMEGA8
.LIST

.def		Temp=r16					;  
.def		Temp_1=r17					;  
.def		Temp_2=r18					;  
.def		LED1=r20					; .  
.def		LED2=r21					; .  
.def		LED3=r22					;  8 

.DSEG
.ORG  0X0060
.CSEG
.ORG $0000

    rjmp RESET          ;  
    reti // INT0        ;      INT0 
    reti // INT1        ;      INT1
	reti // TIMER2 COMP ;  - 2
    reti // TIMER2 OVF  ; - 2 
    reti // TIMER1 CAPT ;  - 1 
    reti // TIMER1 COMPA;   - 1 
    reti // TIMER1 COMPB;   - 1 
    reti // TIMER1_OVF  ; - 1 
    reti // TIMER0_OVF  ; - 0 
    reti // SPI         ;    SPI 
    reti // UART        ;   0 
    reti // UART        ;  UART PORTD 0 18 
    reti // UART        ;   0
    reti // ADC_INT     ;  
    reti // EE_RDY      ;  
    reti // ANA_COMP    ; 
	reti // TWI         ;  
    reti // SPM_RDY     ;     

RESET:
; Initiire Stapel
	ldi temp, HIGH(RAMEND) ; Initiiere MSB Stapel
	out SPH,temp
	ldi temp, LOW(RAMEND) ; Initiiere LSB Stapel
	out SPL,temp
; Init Port B
    ldi temp,0 
	out DDRB,temp
	ldi temp,0xff 
	out DDRD,temp
    ldi temp,0 
	out PORTB,temp
	ldi temp,1<<ACD
	out ACSR,temp
	sei

;*****************************************************************
;  DS18B20
;*****************************************************************
Next:       rcall	DQ_Init				;  DS18B20
			ldi		Temp, 0xCC			;  
			rcall	DQ_write			; Skip ROM (CCH)
			ldi		Temp, 0x44			;  
			rcall	DQ_write			; Start Conv (44H)
;*****************************************************************
;      DS18B20
;*****************************************************************
Wait:		rcall	IN_bite				;    DS18B20
			cpi		Temp, 0xFF			;  ?
			brne	Wait				; , 
			rcall	DQ_Init				; ,  
			ldi		Temp, 0xCC			;  
			rcall	DQ_write			; Skip ROM (CCH)
			ldi		Temp, 0xBE			;  
			rcall	DQ_write			; Read Scratchpad (0BEH)
			rcall	IN_bite				;   temp_LSB  DS18B20
			mov		LED2, Temp			;   LED2
			rcall	IN_bite				;   temp_MSB  DS18B20
			mov		LED1, Temp			;   LED1
;*****************************************************************
;  DS18B20
;*****************************************************************
DQ_Init:	rcall	DQ_hi				; PB  
			rcall	DQ_lo				; PB  
			ldi		Temp_1, 120			; 
			rcall	DS_delay			; 600 uSecs
			rcall	DQ_hi				; DQ  
			ldi		Temp_1, 14			; 
			rcall	DS_delay			; 70 uSecs
			sbic	PINB, PB2			;  ?
			rjmp	Err_DQ				; , 
			clt							;  
			ldi		Temp_1, 100			; 
			rcall	DS_delay			; 500 uSecs
			ret							; 
;*****************************************************************
; 
;*****************************************************************
Err_DQ:    
            ret
;*****************************************************************
;  DQ  
;*****************************************************************
DQ_hi:		cbi		DDRB, PB2			; PB  
			ret							; 
;*****************************************************************
;  DQ  
;*****************************************************************
DQ_lo:		cbi		PORTB, PB2			; PB2  0
			sbi		DDRB, PB2			; PB  
			ret							; 
;*****************************************************************
;    DS18B20
;*****************************************************************
IN_bite:	ldi		LED3, 8				;  8 
			clr		Temp				; .  -
IN_bite_1:  rcall   DQ_lo       		; PB  
            rcall   DQ_hi       		; PB  
            nop                     	;  nop
            sbis	PINB, PB2			;   0  1 ? 
            clc							; 0, =0
            sbic	PINB, PB2			; 1,     
            sec							; 1, =1
            ror 	Temp				;  Temp
            ldi		Temp_1, 8			; 
            rcall	DS_delay			; 40 uSecs
            dec		LED3				;  ?
            brne   	IN_bite_1			; ,  
            ret							; 
;*****************************************************************
;    DS18x20
;*****************************************************************
DQ_write:	ldi		LED3, 8				;  8 
Metka_1:	lsr 	Temp				;   0  -> CF
			brcs 	Out_1				;   CF=1
			rjmp 	Out_0				;
Metka_2:	dec		LED3				;
			brne	Metka_1				;
			ret							; 
;*****************************************************************
;     "0"
;*****************************************************************
Out_0:		rcall	DQ_lo				; PB  
			ldi		Temp_1, 12			; 
			rcall	DS_delay			; 60 uSecs
			rcall	DQ_hi				; DQ  
			rjmp	Metka_2				;
;*****************************************************************
;     "1"
;*****************************************************************
Out_1:		rcall	DQ_lo				; PB  
			rcall	DQ_hi				; PB  
			ldi		Temp_1, 12			; 
			rcall	DS_delay			; 60 uSecs
			rjmp	Metka_2				;
;*****************************************************************
;  5 uSecs * Temp_1
;*****************************************************************
DS_delay:	ldi 	Temp_2, 10			;
cycle:		dec 	Temp_2				;
			brne	cycle				;
			nop							;
			rjmp	XX					;
XX:			rjmp	XXX					;
XXX:		rjmp	XXXX				;
XXXX:		dec 	Temp_1				;
			brne	DS_delay			;
			ret							; 
;*****************************************************************
